/*
 * DEBUGGER code
 * 
 * On "publish", when buffer is free, debugger stores arbitrary variables 
 * content into, and mark this buffer as filled
 * 
 * 
 * Buffer content is read asynchronously, (from non real time part), 
 * and then buffer marked free again.
 *  
 * 
 * */
#ifdef TARGET_DEBUG_AND_RETAIN_DISABLE

void __init_debug    (void){}
void __cleanup_debug (void){}
void __retrieve_debug(void){}
void __publish_debug (void){}

#else

#include "iec_types_all.h"
#include "POUS.h"
/*for memcpy*/
#include <string.h>
#include <stdio.h>

#ifndef TARGET_ONLINE_DEBUG_DISABLE
#define BUFFER_SIZE 237

/* Atomically accessed variable for buffer state */
#define BUFFER_FREE 0
#define BUFFER_BUSY 1
static long buffer_state = BUFFER_FREE;

/* The buffer itself */
char debug_buffer[BUFFER_SIZE];

/* Buffer's cursor*/
static char* buffer_cursor = debug_buffer;
#endif

static unsigned int retain_offset = 0;
/***
 * Declare programs 
 **/
extern PLC_TRAFFIC_UNO RES0__INSTANCE0;

/***
 * Declare global variables from resources and conf 
 **/
extern       PLC_TRAFFIC_UNO   RES0__INSTANCE0;

typedef const struct {
    void *ptr;
    __IEC_types_enum type;
} dbgvardsc_t;

static dbgvardsc_t dbgvardsc[] = {
{&(RES0__INSTANCE0.STATUS), BOOL_ENUM},
{&(RES0__INSTANCE0.O_LEDRED), WORD_ENUM},
{&(RES0__INSTANCE0.O_LEDORANGE), WORD_ENUM},
{&(RES0__INSTANCE0.O_LEDGREEN), WORD_ENUM},
{&(RES0__INSTANCE0.TOF0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF0.IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF0.PT), TIME_ENUM},
{&(RES0__INSTANCE0.TOF0.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF0.ET), TIME_ENUM},
{&(RES0__INSTANCE0.TOF0.STATE), SINT_ENUM},
{&(RES0__INSTANCE0.TOF0.PREV_IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF0.CURRENT_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.TOF0.START_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.IN0), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.VAL0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.OUT0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.OUT1), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON4.OUT), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.IN0), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.VAL_COMP), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON0.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG0.CLK), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG0.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG0.M), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG2.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG2.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG2.CLK), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG2.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG2.M), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.IN0), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.VAL_COMP), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON2.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.IN0), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.VAL0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.OUT0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.OUT1), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON5.OUT), WORD_ENUM},
{&(RES0__INSTANCE0.TOF2.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF2.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF2.IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF2.PT), TIME_ENUM},
{&(RES0__INSTANCE0.TOF2.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF2.ET), TIME_ENUM},
{&(RES0__INSTANCE0.TOF2.STATE), SINT_ENUM},
{&(RES0__INSTANCE0.TOF2.PREV_IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF2.CURRENT_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.TOF2.START_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.F_TRIG3.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG3.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG3.CLK), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG3.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.F_TRIG3.M), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.IN0), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.VAL_COMP), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON3.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.PT), TIME_ENUM},
{&(RES0__INSTANCE0.TOF3.Q), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.ET), TIME_ENUM},
{&(RES0__INSTANCE0.TOF3.STATE), SINT_ENUM},
{&(RES0__INSTANCE0.TOF3.PREV_IN), BOOL_ENUM},
{&(RES0__INSTANCE0.TOF3.CURRENT_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.TOF3.START_TIME), TIME_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.VAR0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.IN0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.IN1), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.VAR_T), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.VAR_F), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_F0.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.IN0), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.VAL_COMP), WORD_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.W_TO_B_ON4.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.IN0), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.IN1), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.VAL0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.VAL1), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.VAL2), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.VAL3), BOOL_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.OUT0), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.OUT1), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.OUT), WORD_ENUM},
{&(RES0__INSTANCE0.B_TO_W_ON_OFF0.OUT2), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.EN), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.ENO), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.VAR0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.VAL0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.IN0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.IN1), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.VAR_T), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.VAR_F), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.OUT0), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.OUT1), BOOL_ENUM},
{&(RES0__INSTANCE0.AND_VAR_T0.OUT), BOOL_ENUM},
{&(RES0__INSTANCE0.OR63_OUT), BOOL_ENUM}
};

typedef void(*__for_each_variable_do_fp)(dbgvardsc_t*);
void __for_each_variable_do(__for_each_variable_do_fp fp)
{
    unsigned int i;
    for(i = 0; i < sizeof(dbgvardsc)/sizeof(dbgvardsc_t); i++){
        dbgvardsc_t *dsc = &dbgvardsc[i];
        if(dsc->type != UNKNOWN_ENUM) 
            (*fp)(dsc);
    }
}

#define __Unpack_case_t(TYPENAME) \
        case TYPENAME##_ENUM :\
            *flags = ((__IEC_##TYPENAME##_t *)varp)->flags;\
            forced_value_p = *real_value_p = &((__IEC_##TYPENAME##_t *)varp)->value;\
            break;

#define __Unpack_case_p(TYPENAME)\
        case TYPENAME##_O_ENUM :\
            *flags = __IEC_OUTPUT_FLAG;\
        case TYPENAME##_P_ENUM :\
            *flags |= ((__IEC_##TYPENAME##_p *)varp)->flags;\
            *real_value_p = ((__IEC_##TYPENAME##_p *)varp)->value;\
            forced_value_p = &((__IEC_##TYPENAME##_p *)varp)->fvalue;\
            break;

void* UnpackVar(dbgvardsc_t *dsc, void **real_value_p, char *flags)
{
    void *varp = dsc->ptr;
    void *forced_value_p = NULL;
    *flags = 0;
    /* find data to copy*/
    switch(dsc->type){
        __ANY(__Unpack_case_t)
        __ANY(__Unpack_case_p)
    default:
        break;
    }
    if (*flags & __IEC_FORCE_FLAG)
        return forced_value_p;
    return *real_value_p;
}

void Remind(unsigned int offset, unsigned int count, void * p);

void RemindIterator(dbgvardsc_t *dsc)
{
    void *real_value_p = NULL;
    char flags = 0;
    UnpackVar(dsc, &real_value_p, &flags);

    if(flags & __IEC_RETAIN_FLAG){
        USINT size = __get_type_enum_size(dsc->type);
        /* compute next cursor positon*/
        unsigned int next_retain_offset = retain_offset + size;
        /* if buffer not full */
        Remind(retain_offset, size, real_value_p);
        /* increment cursor according size*/
        retain_offset = next_retain_offset;
    }
}

extern int CheckRetainBuffer(void);
extern void InitRetain(void);

void __init_debug(void)
{
    /* init local static vars */
#ifndef TARGET_ONLINE_DEBUG_DISABLE	
    buffer_cursor = debug_buffer;
    buffer_state = BUFFER_FREE;
#endif

    retain_offset = 0;
    InitRetain();
    /* Iterate over all variables to fill debug buffer */
    if(CheckRetainBuffer()){
    	__for_each_variable_do(RemindIterator);
    }else{
    	char mstr[] = "RETAIN memory invalid - defaults used";
        LogMessage(LOG_WARNING, mstr, sizeof(mstr));
    }
    retain_offset = 0;
}

extern void InitiateDebugTransfer(void);
extern void CleanupRetain(void);

extern unsigned long __tick;

void __cleanup_debug(void)
{
#ifndef TARGET_ONLINE_DEBUG_DISABLE	
    buffer_cursor = debug_buffer;
    InitiateDebugTransfer();
#endif    

    CleanupRetain();
}

void __retrieve_debug(void)
{
}


void Retain(unsigned int offset, unsigned int count, void * p);

static inline void BufferIterator(dbgvardsc_t *dsc, int do_debug)
{
    void *real_value_p = NULL;
    void *visible_value_p = NULL;
    char flags = 0;

    visible_value_p = UnpackVar(dsc, &real_value_p, &flags);

    if(flags & ( __IEC_DEBUG_FLAG | __IEC_RETAIN_FLAG)){
        USINT size = __get_type_enum_size(dsc->type);

#ifndef TARGET_ONLINE_DEBUG_DISABLE	
        if(flags & __IEC_DEBUG_FLAG){
            /* copy visible variable to buffer */;
            if(do_debug){
                /* compute next cursor positon.
                   No need to check overflow, as BUFFER_SIZE
                   is computed large enough */
		if((dsc->type == STRING_ENUM)   ||
		   (dsc->type == STRING_P_ENUM) ||
		   (dsc->type == STRING_O_ENUM)){
                    /* optimization for strings */
                    size = ((STRING*)visible_value_p)->len + 1;
                }
                char* next_cursor = buffer_cursor + size;
                /* copy data to the buffer */
                memcpy(buffer_cursor, visible_value_p, size);
                /* increment cursor according size*/
                buffer_cursor = next_cursor;
            }
            /* re-force real value of outputs (M and Q)*/
            if((flags & __IEC_FORCE_FLAG) && (flags & __IEC_OUTPUT_FLAG)){
                memcpy(real_value_p, visible_value_p, size);
            }
        }
#endif	

        if(flags & __IEC_RETAIN_FLAG){
            /* compute next cursor positon*/
            unsigned int next_retain_offset = retain_offset + size;
            /* if buffer not full */
            Retain(retain_offset, size, real_value_p);
            /* increment cursor according size*/
            retain_offset = next_retain_offset;
        }
    }
}

void DebugIterator(dbgvardsc_t *dsc){
    BufferIterator(dsc, 1);
}

void RetainIterator(dbgvardsc_t *dsc){
    BufferIterator(dsc, 0);
}


unsigned int retain_size = 0;

/* GetRetainSizeIterator */
void GetRetainSizeIterator(dbgvardsc_t *dsc)
{
    void *real_value_p = NULL;
    char flags = 0;
    UnpackVar(dsc, &real_value_p, &flags);

    if(flags & __IEC_RETAIN_FLAG){
        USINT size = __get_type_enum_size(dsc->type);
        /* Calc retain buffer size */
        retain_size += size;
    }
}

/* Return size of all retain variables */
unsigned int GetRetainSize(void)
{
    __for_each_variable_do(GetRetainSizeIterator);
    return retain_size;
}


extern void PLC_GetTime(IEC_TIME*);
extern int TryEnterDebugSection(void);
extern long AtomicCompareExchange(long*, long, long);
extern long long AtomicCompareExchange64(long long* , long long , long long);
extern void LeaveDebugSection(void);
extern void ValidateRetainBuffer(void);
extern void InValidateRetainBuffer(void);

void __publish_debug(void)
{
    retain_offset = 0;
    InValidateRetainBuffer();
    
#ifndef TARGET_ONLINE_DEBUG_DISABLE 
    /* Check there is no running debugger re-configuration */
    if(TryEnterDebugSection()){
        /* Lock buffer */
        long latest_state = AtomicCompareExchange(
            &buffer_state,
            BUFFER_FREE,
            BUFFER_BUSY);
            
        /* If buffer was free */
        if(latest_state == BUFFER_FREE)
        {
            /* Reset buffer cursor */
            buffer_cursor = debug_buffer;
            /* Iterate over all variables to fill debug buffer */
            __for_each_variable_do(DebugIterator);
            
            /* Leave debug section,
             * Trigger asynchronous transmission 
             * (returns immediately) */
            InitiateDebugTransfer(); /* size */
        }else{
            /* when not debugging, do only retain */
            __for_each_variable_do(RetainIterator);
        }
        LeaveDebugSection();
    }else
#endif
    {
        /* when not debugging, do only retain */
        __for_each_variable_do(RetainIterator);
    }
    ValidateRetainBuffer();
}

#ifndef TARGET_ONLINE_DEBUG_DISABLE
#define __RegisterDebugVariable_case_t(TYPENAME) \
        case TYPENAME##_ENUM :\
            ((__IEC_##TYPENAME##_t *)varp)->flags |= flags;\
            if(force)\
             ((__IEC_##TYPENAME##_t *)varp)->value = *((TYPENAME *)force);\
            break;
#define __RegisterDebugVariable_case_p(TYPENAME)\
        case TYPENAME##_P_ENUM :\
            ((__IEC_##TYPENAME##_p *)varp)->flags |= flags;\
            if(force)\
             ((__IEC_##TYPENAME##_p *)varp)->fvalue = *((TYPENAME *)force);\
            break;\
        case TYPENAME##_O_ENUM :\
            ((__IEC_##TYPENAME##_p *)varp)->flags |= flags;\
            if(force){\
             ((__IEC_##TYPENAME##_p *)varp)->fvalue = *((TYPENAME *)force);\
             *(((__IEC_##TYPENAME##_p *)varp)->value) = *((TYPENAME *)force);\
            }\
            break;
void RegisterDebugVariable(unsigned int idx, void* force)
{
    if(idx  < sizeof(dbgvardsc)/sizeof(dbgvardsc_t)){
        unsigned char flags = force ?
            __IEC_DEBUG_FLAG | __IEC_FORCE_FLAG :
            __IEC_DEBUG_FLAG;
        dbgvardsc_t *dsc = &dbgvardsc[idx];
        void *varp = dsc->ptr;
        switch(dsc->type){
            __ANY(__RegisterDebugVariable_case_t)
            __ANY(__RegisterDebugVariable_case_p)
        default:
            break;
        }
    }
}

#define __ResetDebugVariablesIterator_case_t(TYPENAME) \
        case TYPENAME##_ENUM :\
            ((__IEC_##TYPENAME##_t *)varp)->flags &= ~(__IEC_DEBUG_FLAG|__IEC_FORCE_FLAG);\
            break;

#define __ResetDebugVariablesIterator_case_p(TYPENAME)\
        case TYPENAME##_P_ENUM :\
        case TYPENAME##_O_ENUM :\
            ((__IEC_##TYPENAME##_p *)varp)->flags &= ~(__IEC_DEBUG_FLAG|__IEC_FORCE_FLAG);\
            break;

void ResetDebugVariablesIterator(dbgvardsc_t *dsc)
{
    /* force debug flag to 0*/
    void *varp = dsc->ptr;
    switch(dsc->type){
        __ANY(__ResetDebugVariablesIterator_case_t)
        __ANY(__ResetDebugVariablesIterator_case_p)
    default:
        break;
    }
}

void ResetDebugVariables(void)
{
    __for_each_variable_do(ResetDebugVariablesIterator);
}

void FreeDebugData(void)
{
    /* atomically mark buffer as free */
    AtomicCompareExchange(
        &buffer_state,
        BUFFER_BUSY,
        BUFFER_FREE);
}
int WaitDebugData(unsigned long *tick);
/* Wait until debug data ready and return pointer to it */
int GetDebugData(unsigned long *tick, unsigned long *size, void **buffer){
    int wait_error = WaitDebugData(tick);
    if(!wait_error){
        *size = buffer_cursor - debug_buffer;
        *buffer = debug_buffer;
    }
    return wait_error;
}
#endif
#endif

